#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;
#define VI vector < int >
#define EVERY(c) (c).begin(), (c).end()
#define PB push_back
#define REP(i,n) for (int i = 0; i < (n); ++i)
#define VVI vector < VI >
#define VS vector <string>

/*
* Rozwiazanie w C++ problemu F z finalow ACM ICPC 2006
* (Problem "Zegar" = "Building a Clock")
* Autorzy: Tomasz Kazana i Wojciech Kazana
*/

int gcd (int a, int b) {return b ? gcd(b, a%b) : a; }

void skroc(int &x, int &y) {
int skr = gcd(abs(x),abs(y));
x /= skr; y /= skr;
}

void przelicz(int &x, int &y, int t1, int t2) {
 x *= -t1;
 y *= t2;
 skroc(x,y);           
}

int N, R;
int tab[256];
VVI wzorce[7];
int numer;
int kije, kolka;
string wyn, wyn1, wyn2;

void wylicz_wzorce() {
VI a; a.PB(1);
wzorce[0].resize(1);
wzorce[1].PB(a);
a.PB(1);
wzorce[2].PB(a);
for(int i=3;i<=6;++i) {
        REP(j,wzorce[i-2].size()) {
                                  wzorce[i].PB(wzorce[i-2][j]);
                                  wzorce[i][wzorce[i].size()-1].PB(2);
        }
        REP(j,wzorce[i-1].size()) {
                                  wzorce[i].PB(wzorce[i-1][j]);
                                  wzorce[i][wzorce[i].size()-1].PB(1);
        }
        }
}

int m, h;

int licz[10];
int mian[10];

void probuj_liniowo(VS &dane) {
m = -1; h = -1;
int li = R; licz[0]= R;
int mn = 1; mian[0]= 1;
if (li == 2 && mn == 1) h = 0;
if (li == 24&& mn == 1) m = 0;
for(int k=1;k<dane.size();++k) {
                   przelicz(li, mn, 
                            tab[int((unsigned char)(*(dane[k-1].end() - 1)))],
                            tab[int((unsigned char)(dane[k][0]))]);
                   licz[k] = li;
                   mian[k] = mn;
                   if (h == -1 && li == 2 && mn == 1) h = k;
                   if (m == -1 && li == 24&& mn == 1) m = k;
                   if (h != -1 && m != -1) break; //new
                   }                   
if (m == -1 || h == -1) return;

int pr = max(h,m) + 1;
if (pr > kije) return;

int kol = 1;
REP(i,pr-1) kol += dane[i].size();
if (kije == pr && kol > kolka) return;

string tym = "";
REP(i,m) tym += dane[i];
if (m) tym += dane[m][0];
REP(i,h) tym += dane[i];
if (h) tym += dane[h][0];
if (kije == pr && kol == kolka && tym > wyn) return;

kije = pr;
kolka = kol;
wyn = tym;
wyn1 = wyn2 = "*";
REP(i,m) wyn1 += dane[i] + '-';
if (m) wyn1 += dane[m][0];
REP(i,h) wyn2 += dane[i] + '-';
if (h) wyn2 += dane[h][0];
return;
}

void probuj_luzno(VS &dane, int gdzie, int gr, int jeszcze) {
int li = licz[gdzie];
int mn = mian[gdzie];
int k;
int kon = -1;
if (gr >= dane.size()-2) return;
if (dane[gr+1].size() != 1) return;
for(int k=gr+2;k<dane.size();++k) {
                   przelicz(li, mn,
                   tab[int((unsigned char)(*(dane[k-1].end() - 1)))],
                   tab[int((unsigned char)(dane[k][0]))]);
                   if (li == jeszcze && mn == 1) {
                         kon = k;
                         break;
                         };
                   }
if (kon == -1 || dane[kon].size() != 1) return;

int pr = kon;
if (pr > kije) return;

int kol = 0;
REP(i,kon+1) kol += dane[i].size();
if (kije == pr && kol > kolka) return;

string tym1 = "";
REP(i,gr+1) tym1 += dane[i];
string tym2 = "";
REP(i,gdzie) tym2 += dane[i];
if (gdzie) tym2 += dane[gdzie][0];
for(int i=gr+1;i<=kon;++i) tym2 += dane[i];
if (jeszcze == 24) swap(tym1,tym2);
if (kije == pr && kol == kolka && tym1+tym2> wyn) return;

kije = pr;
kolka = kol;
wyn = tym1+tym2;
wyn1 = wyn2 = "*";
REP(i,gr) wyn1 += dane[i] + '-';
wyn1 += dane[gr][0];
REP(i,gdzie) wyn2 += dane[i] + '-';
if (gdzie) wyn2 += dane[gdzie][0];
for(int i=gr+1;i<kon;++i) wyn2 += dane[i] + '-';
wyn2+= dane[kon];
if (jeszcze==24) swap(wyn1,wyn2);
}

void probuj_wcisnac(VS &dane, int gdzie, int gr, int jeszcze) {
int li = licz[gdzie];
int mn = mian[gdzie];
int k, t1;
int kon = -1;
if (gr >= dane.size()-1) return;
for(int k=gr+1;k<dane.size();++k) {
                   if (k > gr+1)
                   t1 = tab[int((unsigned char)(*(dane[k-1].end() - 1)))];
                   else t1 = tab[int((unsigned char)(*(dane[gdzie].end() - 1)))];
                   przelicz(li, mn, t1, tab[int((unsigned char)(dane[k][0]))]);
                   if (li == jeszcze && mn == 1) {
                         kon = k;
                         break;
                         };
                   }
if (kon == -1 || dane[kon].size() != 1) return;

int pr = kon+1;
if (pr > kije) return;

int kol = 0;
REP(i,kon+1) kol += dane[i].size();
if (kije == pr && kol > kolka) return;

string tym1 = "";
REP(i,gr+1) tym1 += dane[i];
string tym2 = "";
REP(i,gdzie+1) tym2 += dane[i];
for(int i=gr+1;i<=kon;++i) tym2 += dane[i];
if (jeszcze == 24) swap(tym1,tym2);
if (kije == pr && kol == kolka && tym1+tym2> wyn) return;

kije = pr;
kolka = kol;
wyn = tym1+tym2;
wyn1 = wyn2 = "*";
REP(i,gr) wyn1 += dane[i] + '-';
wyn1 += dane[gr][0];
REP(i,gdzie+1) wyn2 += dane[i] + '-';
for(int i=gr+1;i<kon;++i) wyn2 += dane[i] + '-';
wyn2+= dane[kon];
if (jeszcze==24) swap(wyn1,wyn2);
}

void sprawdz(string &s, int k) {
VI &wzor = wzorce[N][k];
VS dane; dane.resize(wzor.size());
int poz = 0;
REP(i,dane.size()) REP(j,wzor[i]) dane[i] += s[poz++];
probuj_liniowo(dane);
if (m == -1 && h == -1) return;
int gr, jeszcze;
if (m == -1) {gr = h; jeszcze = 24;};
if (h == -1) {gr = m; jeszcze = 2;};
if (m != -1 && h != -1) {gr = min(m,h); if (gr == m) jeszcze = 2; else jeszcze = 24;};
if (dane[gr].size() != 1) return;
REP(i,gr) {probuj_luzno(dane, i, gr, jeszcze);
           probuj_wcisnac(dane, i, gr, jeszcze);
           };

}

void pisz_wynik() {
if (numer > 1) printf("\n");
printf("Trial %d", numer);
if (kije == 1000) {
         printf(" IS IMPOSSIBLE\n");
         return;
         };     
printf("\n");
printf("Minutes: %s\n", wyn1.c_str());
printf("Hours:   %s\n", wyn2.c_str());
};

int main() {  
wylicz_wzorce(); 
unsigned char c;
int t;
scanf("%d", &N);
while (N>0) {
      numer++;
      kije = 1000;
      string s = "";
      scanf("%d", &R);
      REP(i,N) {
               c = getchar();
               c = getchar();
               scanf("%d", &t);
               tab[c] = t;
               s += c;
               }
      sort(EVERY(s));
      do {
      REP(i,wzorce[N].size())
      sprawdz(s,i);
      } while(next_permutation(EVERY(s)));
      pisz_wynik();
      scanf("%d", &N);
      }
return 0;  
};
